; Techno 82 august 99
; To make sound (noise) with your TI82...

; The compilation may not work with TASM because of the org at the interrupt routine
; Use Assembly Studio!

#include "CrASH82.inc"

KeyPushed	= TEXT_MEM2	;1 byte
.db "Techno 82",0	
;Efface tout, et affiche les messages
	; from CrASH_Man
	CALL	CR_GRBCopy
	ld	a, (INT_STATE)		; Check out CrASH's interrupt byte
	or	a
	jr	z, Init
	ld	hl, 1A10h
	ld	(GRAF_CURS), hl
	ld	hl, szAnother
	ROM_CALL(D_ZM_STR)
	jp	CR_KHAND

Init:
	ld	hl,0300h
	ld	(CURSOR_POS),hl
	SET	3, (IY+05h)
	LD	HL, txtTop
	ROM_CALL(D_ZT_STR)
	RES	3, (IY+05h)
	LD	HL, 0912h
	LD	(CURSOR_X), HL
	LD	HL,txtHelp
	ROM_CALL(D_ZM_STR)
	LD	HL, 0203h
	LD	(CURSOR_POS), HL
	LD	HL,StrTimber
	ROM_CALL(D_ZT_STR)
	LD	HL, 0204h
	LD	(CURSOR_POS), HL
	LD	HL,StrOctave
	ROM_CALL(D_ZT_STR)
	ld	hl,0106h
	ld	(CURSOR_POS),hl
	ld	a,(Invertor +1)
	bit	2,a
	ld	a,' '
	jr	z,BgDrawLeft
	ld	a,'>'
BgDrawLeft:
	ROM_CALL(TR_CHARPUT)
	ld	a,0Eh
	ld	(CURSOR_COL),a
	ld	a,(Invertor +1)
	bit	3,a
	ld	a,' '
	jr	z,BgDrawRight
	ld	a,'<'
BgDrawRight:
	ROM_CALL(TR_CHARPUT)
	ld	hl, 8400h
	ld	de, 8401h
	ld	(hl), 83h
	ld	bc, 100h
	ldir
	ld	hl, IntLoc
	ld	de, 8383h
	ld	bc, IntEnd-IntStart
	ldir
	call	DisplayInfo
	ld	a, 84h
	ld	i, a
	im	2
	; Initialise le port, etc, etc
	LD   c, 0C0h
	LD   A, c
	OUT  (0), A

		;keyboard commands
Loop:
NotePointer:
	ld	hl,NoteTableStart
	ld	de,04h
RowLoop:
	ld	a,0ffh
	out	(1),a
KeyMask:
	ld	a,11011111b
	out	(1),a
	in	a,(1)
	ld	b,7
ColLoop:
	sra	a
	jr	c,NotPushed
	push	af
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
	call	PlaySound
	pop	hl
	pop	af
	ld	de,04h
NotPushed:
	add	hl,de
	djnz	ColLoop
	push	hl
	ld	hl,KeyMask+1
	rrc	(hl)
	bit	0,(hl)
	pop	hl
	jp	nz,RowLoop
	ld	a,11011111b
	ld	(KeyMask+1),a
	
	ld	a,0ffh
	out	(1),a
	ld	a,10111111b
	out	(1),a
	in	a,(1)
	bit	6,a		;MODE
	jr	z,ExitProg
	ld	hl,KeyPushed
	bit	0,a		;Graph
	jp	z,SoundRight
	bit	4,a		;Y=
	jp	z,SoundLeft

	ld	a,0ffh
	out	(1),a
	ld	a,11111110b
	out	(1),a
	in	a,(1)
	bit	1,a
	jr	z,DownOctave
	bit	2,a
	jr	z,UpOctave
	bit	0,a
	jr	z,DownTimber
	bit	3,a
	jr	z,UpTimber
	ld	(hl),1		;reset KeyPushed
	jp	Loop
ExitProg:
	im	1
	ei	
	LD	A, 0C0h
	OUT	(0), A
	ld	a,(IntTC)
	ld	( IntTC -IntStart + IntLoc ),a
	xor	a
	ld	i, a
	call	GET_KEY
        ret			; Voila ! c'est fini.

DownTimber:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	hl,IntTC
	dec	(hl)
	jr	ChangeTimber
UpTimber:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	hl,IntTC
	inc	(hl)
ChangeTimber:
	jr	nz,CanContinueChT
	ld	(KeyPushed),a
CanContinueChT:
	call	DisplayInfo
	jp	Loop


DownOctave:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	(hl),a
	ld	hl,(NotePointer+1)
	ld	de,NoteTableBg
	call	CP_HL_DE
	jp	z,Loop
	ld	de,- (7*4)
	add	hl,de
	ld	(NotePointer+1),hl
	call	DisplayInfo
	jp	Loop

UpOctave:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	(hl),a
	ld	hl,(NotePointer+1)
	ld	de,NoteTableEnd-(7*4*5)
	call	CP_HL_DE
	jp	z,Loop
	ld	de,7*4
	add	hl,de
	ld	(NotePointer+1),hl
	call	DisplayInfo
	jp	Loop


SoundRight:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	(hl),a
	ld	hl,Invertor +1
	ld	a,(hl)
	xor	00101000b
	ld	(hl),a
	ld	hl,0E06h
	ld	(CURSOR_POS),hl
	bit	3,a
	ld	a,' '
	jr	z,DrawRight
	ld	a,'<'
DrawRight:
	im	1
	ROM_CALL(TR_CHARPUT)
	ld	c,0C0h
	call	DisplayInfo
	jp	Loop
SoundLeft:
	ld	a,(hl)
	dec	a
	jp	nz,Loop
	ld	(hl),a
	ld	hl,Invertor +1
	ld	a,(hl)
	xor	00010100b
	ld	(hl),a
	ld	hl,0106h
	ld	(CURSOR_POS),hl
	bit	2,a
	ld	a,' '
	jr	z,DrawLeft
	ld	a,'>'
DrawLeft:
	im	1
	ROM_CALL(TR_CHARPUT)
	ld	c,0C0h
	call	DisplayInfo
	jp	Loop

DisplayInfo:
	push	af
	push	bc
	push	de
	push	hl
	im	1
	LD	HL, 0903h
	LD	(CURSOR_POS), HL
	LD	hl,(IntTC)
	ld	h,0
	ROM_CALL(D_HL_DECI)				;contains 'ei'
	di
	LD	HL, 0904h
	LD	(CURSOR_POS), HL
	ld	hl,(NotePointer+1)
	ld	de,((NoteTableBg - (7*4*2)) ^ 0ffffh)+1 ; - (NoteTableBg - (7*4*2)) 
	add	hl,de
	ld	a,4*7					;size*nb of keys in a row
	call	DIV_HL_A
	ROM_CALL(D_HL_DECI)
	di
	ld	hl,PSInt
	ld	(hl),0fbh		;OPOCODE for ei
	LD	a,(IntTC)
	or	a
	jr	nz,DIIntOn
	ld	(hl),0f3h		;di
DIIntOn:
	pop	hl
	pop	de
	pop	bc
	pop	af
	ret

;;;;;;;;
; Fait du bruit par DHORDAIN Florent
; 26 * HL cycles dans DLoop
; 78 cycles dans le le reste de SoundLoop

; Cycles dans:          ;Dloop  ;Le reste...

PlaySound:
	im	2
PSInt:
	di
SoundLoop:
        PUSH HL                 ; 11
DLoop:
        DEC  HL         ;  6
        LD   A, H       ;  4
        OR   L          ;  4
        JR   NZ, DLoop  ; 12    ;  7
        POP  HL                 ; 10
Play:
        LD   A, c               ;  4
Invertor:
        XOR  00111100b          ;  7
        LD   c, A               ;  4
        OUT  (0), A             ; 11
        DEC  DE                 ;  6
        LD   A, D               ;  4
        OR   E                  ;  4
        JP   NZ, SoundLoop      ; 10
DonePlay:
	di
	im	1
	RET

; Total des cycles:     ; 26	;78

;;;;;Messages;;;;;
;;;;;;		;;;;;;;0123456789ABCDEF
txtTop:		.byte " Techno 82 ",0
txtHelp:	.byte "Press ",0c1h,"MODE] to exit",0
szAnother:	.DB "Disable the interrupt",0
StrTimber:	.db "Timber:",0
StrOctave:	.db "Octave:",0
;;;;;;;Data : 	DE,HL	-> Duration, Frequency
; Thank you very much for these numbers Florent DHORDAIN !!!
NoteTableBg:
	.dw	0FFFFh,1		;;
	.dw	13,1760
	.dw	14,1661
	.dw	15,1568
	.dw	16,1479
	.dw	16,1396
	.dw	17,1318

	.dw	04FFFh,1
	.dw	19,1243
	.dw	20,1173
	.dw	21,1107
	.dw	22,1045
	.dw	23,986
	.dw	25,931

	.dw	0FFFh,1
	.dw	26,878
	.dw	28,829
	.dw	29,782
	.dw	31,738
	.dw	33,696
	.dw	35,657
NoteTableStart:
	.dw	08FFh,1
	.dw	37,620
	.dw	39,585
	.dw	42,552
	.dw	44,521
	.dw	47,491
	.dw	49,463

	.dw	0FFFFh,1
	.dw	52,437
	.dw	55,412
	.dw	59,389
	.dw	62,367
	.dw	66,346
	.dw	70,326

	.dw	04FFFh,1
	.dw	74,308
	.dw	79,290
	.dw	83,274
	.dw	88,258		;A 440
	.dw	93,244
	.dw	99,230

	.dw	0FFFh,1
	.dw	104,217
	.dw	111,204
	.dw	118,192
	.dw	125,181
	.dw	132,171
	.dw	140,161

	.dw	08FFh,1
	.dw	148,152
	.dw	157,143
	.dw	166,135
	.dw	176,127
	.dw	186,120
	.dw	197,113

	.dw	0FFFFh,1
	.dw	210,106
	.dw	222,100
	.dw	236,95
	.dw	248,90
	.dw	262,85
	.dw	278,80

	.dw	04FFFh,1
	.dw	296,75
	.dw	312,71
	.dw	335,66
	.dw	350,63
	.dw	372,59
	.dw	398,55

	.dw	0FFFh,1
	.dw	420,52
	.dw	444,49
	.dw	471,46
	.dw	502,43
	.dw	525,41
	.dw	563,38

	.dw	08FFh,1
	.dw	592,36
	.dw	624,34
	.dw	660,32
	.dw	700,30
	.dw	745,28
	.dw	797,26

	.dw	0FFFFh,1
	.dw	825,25
	.dw	889,23
	.dw	924,22
	.dw	1005,20
	.dw	1051,19
	.dw	1101,18

	.dw	04FFFh,1
	.dw	1156,17
	.dw	1285,15
	.dw	1361,14
	.dw	1446,13
	.dw	1446,13
	.dw	1542,12

;	.dw	0FFFh,1
;	.dw	1653,10
;	.dw	1780,9
;	.dw	1929,8
;	.dw	1929,8
;	.dw	2105,7
;	.dw	2317,6
NoteTableEnd:

IntLoc:
.org	8383h
IntStart:
	ex	af,af'
	exx
IntTC		= $ +1
	ld	hl,0000h
	add	hl,hl
	add	hl,hl
TimeLoop:
	dec	hl
	ld	a,l
	or	h
	jr	nz,TimeLoop
	;;;	courtesy of Jeremy Wazny
	xor a                  ;Not sure about this value, but seems to work
	out ($3),a             ;also unsure about why the first out is necessary
	ld a,%00000010
	out ($3),a
	exx
	ex	af,af'
	ei
	;;;;
	reti

;;	jp	0038h
IntEnd:

.END